/*$$$ 
<filter id="rippleShader" label="$$$/Shader/Ripple=Ripple" category="effects" margin="100" pixelLocal="false" samplingMode="linear" vartype="custom" >
	<var varname="amplitude" label="$$$/Shader/Amplitude=Amplitude" type="number" min="1.0" max="100.0" default="45" numPrecision="1" numFactor="1.0" />
	<var varname="frequency" label="$$$/Shader/Frequency=Frequency" type="number" min="1.0" max="100.0" default="12" numPrecision="1" numFactor="1.0" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform vec2 tt_uniform_imagesize;
uniform vec2 tt_uniform_surfacesize;
uniform vec2 tt_uniform_pixelsize;

uniform vec4 image_pixeloffsetscale;

uniform float amplitude;
uniform float frequency;
uniform vec2 center;

varying vec2 mainTexCoord;

const float PI = 3.14159265;

void main()
{
	float surfWidth  = float(tt_uniform_surfacesize.x);
	float surfHeight = float(tt_uniform_surfacesize.y);
	float imgWidth   = float(tt_uniform_imagesize.x);
	float imgHeight  = float(tt_uniform_imagesize.y);

	vec2 halfimg;
	vec2 ripcenter = center;
	halfimg.x = imgWidth  / 2.0;
	halfimg.y = imgHeight / 2.0;

	ripcenter *= halfimg;
	ripcenter += halfimg;
	
	vec2 coord = mainTexCoord;
	coord.x *= surfWidth;
	coord.y *= surfHeight;
	coord += image_pixeloffsetscale.xy;
	coord -= ripcenter;
	coord /= image_pixeloffsetscale.z;

 	vec2 myCoord = coord/64.0;
 	float t = PI * frequency;
	float r = length(myCoord)*t/16.0;
	float s = sin( r );
	coord += amplitude * s / 2.0;
	
	coord *= image_pixeloffsetscale.z;
	coord += ripcenter;
	coord -= image_pixeloffsetscale.xy;
	coord.x /= surfWidth;
	coord.y /= surfHeight;

	gl_FragColor = texture2D(tt_uniform_maintexture, coord.xy);
}