/*$$$ 
<filter id="stampShader" label="$$$/Shader/Stamp Pattern=Stamp Pattern" category="effects" vartype="custom" pixelLocal="false">
	<var varname="scale" label="$$$/Shader/Scale=Scale" doesScale="true" numFactor="100" type="number" min="0.25" max="4" default="2" />
	<var varname="direction" label="$$$/Shader/Angle=Angle" type="angle" min="0" max="360" default="20" />
	<var varname="color1" label="$$$/Shader/Fore Color=Fore Color" type="coloralpha" default="ff000000" />
	<var varname="color2" label="$$$/Shader/Back Color=Back Color" type="coloralpha" default="ffffffff" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform vec2 tt_uniform_surfacesize;

uniform vec4 image_pixeloffsetscale;

uniform vec4 color1;
uniform vec4 color2;

uniform float direction;
uniform float scale;

varying vec2 mainTexCoord;

void main()
{
	const float PI = 3.14159265358979323846264338327950288;

	float angle = PI*direction/180.0;
	float val;
	float curY;
	vec4 dst;
	vec2 coord;
    vec2 rot;

    dst = texture2D( tt_uniform_maintexture, mainTexCoord );
    
    
	val = (dst.r + dst.g + dst.b)/3.0;
    
    val = floor(val*5.0+0.5)/5.0;
    
    coord = mainTexCoord * tt_uniform_surfacesize + image_pixeloffsetscale.xy;

    rot.x = coord.x * cos(angle) + coord.y * sin(angle);
    rot.y = coord.x * -sin(angle) + coord.y * cos(angle);
    
	curY = rot.y + scale*2.0*sin(rot.x*PI/(20.0*scale));
	
    curY = mod(curY,6.0*scale)/(6.0*scale);
    curY = 2.0*(abs(curY - 0.5));
    
    val = smoothstep(-0.25 + val,0.25 + val,curY);

	dst = mix(color2,color1,val);
	
	SHIFTCOMPS(dst)
	
	gl_FragColor = dst;
	
}
