/*$$$ 
<filter id="tintShader" label="$$$/Shader/Tint=Tint" category="effects" vartype="custom" >
	<var varname="intensity" label="$$$/Shader/Intensity=Intensity" type="number" numFactor="100" min="0" max="1" default="1.0" />
	<var varname="color1" label="$$$/Shader/Color=Color" type="color" default="65DA62" />
	<var varname="luminosity" label="$$$/Shader/Luminosity=Luminosity" type="number" numFactor="100" min="0" max="1" default="1.0" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform vec3 color1;

uniform float luminosity;
uniform float intensity;
varying vec2 mainTexCoord;

void main()
{
    const mat4 YIQMatrix = mat4(
            0.299,  0.596,  0.212, 0.000,
            0.587, -0.275, -0.523, 0.000,
            0.114, -0.321,  0.311, 0.000,
            0.000,  0.000,  0.000, 1.000
        );

    const mat4 inverseYIQ = mat4(
            1.0,    1.0,    1.0,    0.0,
            0.956, -0.272, -1.10,  0.0,
            0.621, -0.647,  1.70,   0.0,
            0.0,    0.0,    0.0,    1.0
        );
    
    const vec3 YIQVy = vec3(0.596, -0.275, -0.321);
    
    const vec3 YIQVz = vec3(0.212, -0.523, 0.311);

	vec4 col;
	vec3 tintCol = color1;
	vec4 simpleTintCol;
	vec4 rgbaCol;
	vec4 dst;
	
	vec3 bwVect = vec3(0.299,0.587,0.114);
	
    col = texture2D( tt_uniform_maintexture, mainTexCoord );
	
	SHIFTCOMPS(col)
	
	vec4 yiqCol = YIQMatrix * col;
	simpleTintCol.rgb = tintCol*dot(col.rgb,bwVect);
	simpleTintCol.a = col.a;
	
	yiqCol.yz =vec2(dot(YIQVy, tintCol), dot(YIQVz, tintCol));
	
	rgbaCol = inverseYIQ *yiqCol;
	
	rgbaCol = mix(rgbaCol,simpleTintCol,1.0 - luminosity);
	
	dst = mix(col,rgbaCol,intensity);
	
	SHIFTCOMPS(dst)
	
	gl_FragColor.rgb = min(dst.rgb,dst.a);
	gl_FragColor.a = dst.a;
	
}
